var in_progress = false;
var determined_speed = false;
var time_taken = 0;
var items_per_page = 0;
var queued = Array();
var $dialog = null;
var parentFilterDiv;
var license = null;

(function ($) {

    "use strict";

    $(function () {

        var MagicPageAdminInstallation = (function () {
            $(document).on('click', '.choose-install-options', chooseFilters);

            function option_exists(select, value) {
                if ($(select).has('option:contains("' + value + '")').length) {
                    return true;
                }
                return false;
            }

            function chooseFilters() {
                parentFilterDiv = $(this).parents('.magic_page_install_now');
                var counties = parentFilterDiv.data('counties');
                var filter = parentFilterDiv.data('filter');

                var county_list = [];

                var html_1 = '<select multiple="multiple" style="width: 400px" id="chosen-counties-to-install"></select>';
                $('#placeholder-chosen-counties-to-install').html(html_1);


                var html_2 = '<select multiple="multiple" style="width: 400px" id="chosen-zip-codes"></select>';
                $('#placeholder-chosen-zip-codes').html(html_2);


                // set the chosen settings
                if (filter) {
                    if (filter.counties && filter.counties.length) {
                        $.each(filter.counties, function (key, value) {
                            var option = $("<option selected=\"selected\" value=" + key + ">" + value + "</option>");
                            $('#chosen-counties-to-install').append(option);
                        });
                    }
                    if (filter.zip && filter.zip.length) {
                        $.each(filter.zip, function (key, value) {
                            var option = $("<option selected=\"selected\" value=" + key + ">" + value + "</option>");
                            $('#chosen-zip-codes').append(option);
                        });
                    }

                    if (!filter.majorCity || filter.majorCity !== 'true') {
                        $('#majorCity').removeAttr('checked');
                    } else if (filter.majorCity !== 'false') {
                        $('#majorCity').attr('checked', 'checked');
                    }

                    if (filter.minPopulation) {
                        $('#min-location-population').val(filter.minPopulation);
                    } else {
                        $('#min-location-population').val('');
                    }

                    if (filter.maxPopulation) {
                        $('#max-location-population').val(filter.maxPopulation);
                    } else {
                        $('#max-location-population').val('');
                    }
                }

                for (var index in counties) {
                    if (!option_exists($('#chosen-counties-to-install'), counties[index])) {
                        var element = {id: counties[index], text: counties[index]};
                        if (counties[index] !== "NULL") {
                            county_list.push(element);
                        }
                    }
                }

                $('#chosen-counties-to-install').select2({
                    data: county_list
                }).trigger('change');

                $('#chosen-zip-codes').select2({
                    tokenSeparators: [","],
                    minimumResultsForSearch: -1,
                    tags: true,
                    createTag: function (params) {
                        var string = '%';
                        var text = params.term;

                        if (text.indexOf(string) === -1) {
                            text = '%' + params.term + '%';
                        }

                        return {
                            id: params.term,
                            text: text,
                            newOption: true
                        };
                    },
                    templateResult: function (data) {
                        var $result = $("<span></span>");

                        $result.text(data.text);

                        if (data.newOption) {
                            $result.append();
                        }

                        return $result;
                    }}).on('select2:open select2:opening select2:closing', function (event) {
                    $('.select2-results').css('display', 'none');
                }).trigger('change');

                $dialog = $('#magic-page-minify-footprint-dialog').dialog({
                    title: 'Create advanced filters for this region',
                    dialogClass: 'wp-dialog',
                    draggable: true,
                    modal: true,
                    resizable: true,
                    closeOnEscape: true,
                    minWidth: 350,
                    maxWidth: 800,
                    height: 350,
                    width: 500,
                    position: {
                        my: "center",
                        at: "center",
                        of: window
                    },
                    open: function () {
                        if ($.ui && $.ui.dialog && $.ui.dialog.prototype._allowInteraction) {
                            var ui_dialog_interaction = $.ui.dialog.prototype._allowInteraction;
                            $.ui.dialog.prototype._allowInteraction = function (e) {
                                if ($(e.target).closest('.select2-dropdown').length)
                                    return true;
                                return ui_dialog_interaction.apply(this, arguments);
                            };
                        }
                    },
                    _allowInteraction: function (event) {
                        return !!$(event.target).is(".select2-input") || this._super(event);
                    }
                });
            }


            $(document).on('click', '#uninstall_all_databases', uninstallDatabases);

            $(document).on('click', '#apply-region-filter', applyRegionFilter);

            function applyRegionFilter() {
                var obj = $(this);
                obj.text('Please wait...');

                var region = parentFilterDiv.data('region');
                var country = parentFilterDiv.data('country');

                var zip = [];
                var counties = [];

                $.each($("#chosen-counties-to-install").select2('data'), function () {
                    if ($(this)[0].text && $(this)[0].selected === true) {
                        counties.push($(this)[0].text);
                    }
                });

                $.each($("#chosen-zip-codes").select2('data'), function () {
                    if ($(this)[0].text) {
                        zip.push($(this)[0].text);
                    }
                });

                var data = {
                    action: "magic_page_save_region_filter",
                    counties: counties,
                    zip: zip,
                    majorCity: $('#majorCity').is(':checked'),
                    country: country,
                    region: region,
                    minPopulation: $('#min-location-population').val(),
                    maxPopulation: $('#max-location-population').val()
                };

                $.post(ajaxurl, data, function (response) {
                    if (response.data.content) {
                        obj.text('Apply Filters');
                        $('.magic_page_install_now[data-region="' + region + '"]').replaceWith(response.data.content);

                        $('#chosen-counties-to-install').select2('destroy');
                        $('#chosen-zip-codes').select2('destroy');

                        $dialog.dialog('close');
                        parentFilterDiv = null;
                    }
                });
            }


            function uninstallDatabases() {
                $('.magic_page_install_now.completed, .magic_page_install_now.incomplete').each(function (index, element) {
                    if (index === 0) {
                        $(this).find('.uninstallRegion').trigger('click');
                    } else {
                        $(this).find('.uninstallRegion').text('Queued...');
                        $(this).addClass('queued');
                    }
                });

            }



            $(document).on('click', '.uninstallRegion', startRegionUninstall);

            function startRegionUninstall() {
                if ($(this).prop('disabled')) {
                    return false;
                }

                var parent = $(this).parents('.magic_page_install_now');

                $(this).prop('disabled', 'disabled').text('Uninstalling...');

                parent.addClass('deleting');

                parent.find('.div-progress').empty();

                parent.find(".div-progress").circularloader({
                    progressPercent: 0,
                    fontColor: "#ef122f",
                    fontSize: "9px",
                    radius: 15,
                    progressBarWidth: 4,
                    progressBarColor: "#ffa5b1"
                });

                uninstallRegion($(this).data('country'), $(this).data('region'), $(this));
            }

            function uninstallRegion(country, region, element) {
                var parent = element.parents('.magic_page_install_now');

                var data = {
                    action: "magic_page_uninstall_region",
                    region: region,
                    country: country
                };

                $.post(ajaxurl, data, function (response) {
                    var country = parent.data('info').country_slug;
                    var region = parent.data('info').slug;

                    if (response.success === true && response.data && response.data.done === true) {
                        $('#' + country + '_map .' + region).css('fill', '#55a4e2');
                    }

                    if (response.success === true && response.data && response.data.working) {

                        var iteration = element.data('iteration');
                        if (!iteration) {
                            iteration = 0;
                        }

                        iteration++;
                        element.data('iteration', iteration);

                        var countPerIteration = response.data.count;
                        var totalCount = parent.data('info').locations_count;

                        var percent = (countPerIteration * iteration / totalCount) * 100;

                        parent.find(".div-progress").circularloader({
                            progressPercent: percent
                        });

                        uninstallRegion(country, region, element);
                    } else {
                        element.prop('disabled', 'disabled').text('Uninstall Region');

                        element.data('iteration', 0);

                        parent.attr('class', 'magic_page_install_now');
                        parent.find('.div-progress').empty();
                        element.prop('disabled', '');

                        parent.removeClass('queued');

                        if ($('.magic_page_install_now.queued').length) {
                            $('.magic_page_install_now.queued').first().find('.uninstallRegion').trigger('click');
                        }

                    }

                });


            }

            if ($('.countries_data').length) {
                var d = $.parseJSON($('.countries_data').val());
                $.each(d, function (i, region) {
                    $('#' + region.country + '_map').find('.' + region.slug).css('fill', '#55a4e2');
                });
            }




            $('.magic_page_install_now.incomplete').each(function (index, element) {
                $(this).find(".div-progress").circularloader({
                    //progressPercent: 0,
                    fontColor: "#6ece66",
                    fontSize: "9px",
                    radius: 15,
                    progressBarWidth: 4,
                    progressBarColor: "#6ece66",
                    progressPercent: $(this).data('completed')
                });
            });

            $('.magic_page_install_now.completed').each(function () {
                var region_data = $(this).data('info');
                var element = $('#' + region_data.country_slug);
                element.find('.' + region_data.slug).css({fill: "#6ece66"});
            });

            if ($('.magic_page_install_now.completed').length) {
                $('.magic-page-continue-button').show();
            }

            $(document).on('click', '.magic_page_install_now .install-database', startNewFetch);

            function startNewFetch() {
                if ($(this).prop('disabled')) {
                    return false;
                }

                if (in_progress) {
                    $(this).prop('disabled', 'disabled').html('Queued...').addClass('class', 'button-secondary').removeClass('button-primary');
                    queued.push($(this));


                    return false;
                } else {
                    $(this).prop('disabled', 'disabled').html('Please wait...').addClass('class', 'button-secondary').removeClass('button-primary');

                }

                install_pagic_page($(this), true);


            }


            $('#install_all_databases').click(function () {
                if ($(this).prop('disabled')) {
                    return false;
                }

                $(this).prop('disabled', 'disabled');

                $.each($('.magic_page_install_now').not('.completed'), function (i, element) {
                    $(element).find('.install-database.button-primary').trigger('click');
                });

                $(this).removeAttr('disabled');

 
            });

            $('#magic_page_verify_api_key').click(function () {
                var button = $(this);

                if (!button.val()) {
                    return false;
                }

                if (button.attr('disabled')) {
                    return false;
                }

                button.attr('disabled', 'disabled');
                button.val('Verifying KEY... Please wait.')

                var data = {
                    action: "magic_page_verify_api_key",
                    _magicpage_api_key: $('#magic_page_key').val(),
                    _ajax_nonce: $('#schematicNonce').val() // @todo

                };

                $.post(ajaxurl, data, function (response) {
                
                    if (response.success && response.data.status == 'success') {
                        $('#magic_page_key').attr('disabled', 'disabled');

                        button.val('Key Verified!');
                        $('#api_key_error').hide();
                        $('#api_key_success').html(response.data.data);
                        $('#api_key_success_proceed').show();
                        license = response.data.key;
                    } else {
                        if (response.data.status == 'false') {
                            $('#api_key_error').html(response.data.error_note).show();
                            button.removeAttr('disabled');
                            button.val('VERIFY KEY');
                            return false;
                        }

                        button.removeAttr('disabled');
                        button.val('VERIFY KEY');
                        $('#api_key_error').html(response.data.error_note).show();
                    }
                });
            });

            function continue_install() {
                var data = {
                    action: "magic_page_save_api_key",
                    _magicpage_api_key: $('#magic_page_key').val()
                };

                $.post(ajaxurl, data, function (response) {
                    if (response.success) {
                        location.reload();
                    }
                });
            }

            $('#api_key_save').click(function () {

                $('#api_key_success').remove();
                $('#api_key_success_proceed').html('Loading... Please wait');

 
                
                var data = {
                    action: "magic_page_save_api_key",
                    _magicpage_api_key: $('#magic_page_key').val(),
                    key: license,
                    _ajax_nonce: $('#schematicNonce').val() // @todo
                };

                $.post(ajaxurl, data, function (response) {

                    if (response.success) {
                        window.location.replace(response.data.url);
                    }
                });
            });


            var install_pagic_page = function (obj, initial) {
                var region = obj.parents('.magic_page_install_now');
                var region_data = region.data('info');

                if (region_data.locations_count === "0") {
                    region.find(".completed").show();
                    region.addClass('completed');

                    var element = $('#' + region_data.country_slug);
                    element.find('.' + region_data.slug).css({fill: "#6ece66", transition: "2.0s"});

                    obj.text('Install Database').attr('class', 'button install-database button-primary');
                    obj.removeAttr('disabled');

                    if (queued.length) {
                        queued.shift();
                        install_pagic_page(queued[0], true);
                    }


                    return false;
                }

                in_progress = true;

                if (initial && !region.data('completed')) {
                    region.find(".div-progress").circularloader({
                        progressPercent: 0,
                        fontColor: "#6ece66",
                        fontSize: "9px",
                        radius: 15,
                        progressBarWidth: 4,
                        progressBarColor: "#6ece66"
                    });
                }

                var data = {
                    action: "magic_page_insert_db",
                    region: region_data.slug,
                    country: region_data.country_slug,
                    update: obj.hasClass('update-database') ? 'update' : false
                };

                region.removeClass('incomplete');
                obj.removeClass('update-database');


                $.post(ajaxurl, data, function (response) {

                    if(!response.success){
                        alert('Error!');
                        return false;
                    }

                    if (!response.data.next_page) {
                        var percent = 100;

                        obj.text('Install Database').attr('class', 'button install-database button-primary');
                        obj.removeAttr('disabled');

                        region.find(".completed").show();
                        region.addClass('completed');

                        $('.magic-page-continue-button').show();

                        in_progress = false;

                        var element = $('#' + region_data.country_slug);
                        element.find('.' + region_data.slug).css({fill: "#6ece66", transition: "2.0s"});

                        if (queued.length) {
                            install_pagic_page(queued[0], true);
                            queued.shift();
                        }

                    } else {
                        var percent = (response.data.next_page / response.data.last_page) * 100;

                        region.find(".div-progress").circularloader({
                            progressPercent: percent
                        });
                    }

                    if (response.data.next_page) {
                        install_pagic_page(obj, false);
                    }
                });
            };


//            function checkDataInstalled() {
//                if ($('.magic_page_install_now').not('.completed').length) {
//                    $('#database-installation-header').attr('class', 'data-not-installed');
//                } else {
//                    $('#database-installation-header').attr('class', 'data-installed');
//                    $('#install_all_databases').prop('disabled', '');
//                }
//            }


            //

            $('.filterByPopulation').click(function () {
                $(this).parents('.country').find('.filter-by-population-holder').toggleClass('hidden');
            });

            //
            $('.apply-population').click(function () {
                $(this).parents('.country').find('.filter-by-population-holder').toggleClass('hidden');
                var country = $(this).parents('.country').data('country');
                var minPopulation = $(this).parents('.country').find('.minimum-population').val();
                var maxPopulation = $(this).parents('.country').find('.maximum-population').val();

                var __regions = $(this).parents('.country').find('.magic_page_install_now').not('.completed');

                var regions = new Array();
                $.each(__regions, function () {
                    regions.push($(this).data('region'));
                });

                if (minPopulation) {
                    $('.min-population-filter-row').removeClass('hidden');
                } else {
                    $('.min-population-filter-row').addClass('hidden');
                }

                if (maxPopulation) {
                    $('.max-population-filter-row').removeClass('hidden');
                } else {
                    $('.max-population-filter-row').addClass('hidden');
                }

                $('body').append('<div id="overlay-applying-filter"><div id="text-applying-filter">Applying the population filter to all regions. This will take a while, please wait.</div></div>');


                var data = {
                    action: "magic_page_save_population",
                    country: country,
                    minPopulation: minPopulation,
                    maxPopulation: maxPopulation,
                    regions: regions
                };

                $.post(ajaxurl, data, function (response) {
                    if (response.data.content) {
                        $('.min-population').text(minPopulation);
                        $('.max-population').text(maxPopulation);

                        $.each(response.data.content, function (region, data) {
                            $('.magic_page_install_now[data-region="' + region + '"]').replaceWith(data);
                        });
                    }

                    $('#overlay-applying-filter').remove();
                });
            });


            function format(item, state) {
                if (!item.id) {
                    return item.text;
                }

                var url = $('#countries-databases').data('flags-url');
                var img = $("<img />", {
                    class: "img-flag",
                    width: 26,
                    src: url + item.element.value.toLowerCase() + ".svg"
                });
                var span = $("<span>", {
                    text: " " + item.text
                });
                span.prepend(img);
                return span;
            }

            $("#countries-databases").select2({
                templateResult: function (item) {
                    return format(item, false);
                }
            }).on('select2:select', function (e) {

                var data = {
                    action: "magic_page_save_database_chosen_country",
                    chosenCountry: $("#countries-databases").val()
                };

                $.post(ajaxurl, data, function (response) {
                    if (response.success === true) {
                        location.reload();
                    }
                });

            });

            $('#force-database-refresh').click(function () {
           

                $('.country').css('opacity', '0.5');

                var data = {
                    action: "magic_page_force_database_refresh"
                };

                $.post(ajaxurl, data, function (response) {
                    if (response.success === true) {
                        location.reload();
                    }
                });
            });


        }(MagicPageAdminInstallation));

    });

})(jQuery);