var stillScrolling = false;

(function ($) {
    "use strict";

    $(document).ready(function () {
        var MagicPageAdmin = (function () {
            // sitemapEnabled
            $('#magicPageXmlSitemap').click(function () {
                if ($(this).prop('checked')) {
                    $('.sitemapEnabled').show();
                } else {
                    $('.sitemapEnabled').hide();
                }
            });


            $('#resetLicenseData').click(function () {
                var data = {
                    action: 'magicpage_reset_license_data'
                };

                $.post(ajaxurl, data, function (response) {
                    alert('Success. You should be getting your new domain license.')
                });
            });


            $('.compatabiltyMode').click(function () {

                $('.compatabiltyMode').removeClass('hidden');
                $(this).addClass('hidden');


                var data = {
                    action: 'magicpage_compatability_mode',
                    mode: $(this).data('mode')
                };


                $.post(ajaxurl, data, function (response) {
                    alert('Success.')
                });
            });



            $(document).on('click', '#hidden-unhide', hiddenUnhide);
            function hiddenUnhide() {
                var data = {
                    action: "magic_page_hidden_unhide"
                };

                $.post(ajaxurl, data, function (response) {
                    if (response.success) {
                        $('#hidden-for-all').addClass('hidden');
                        $('#_magicpage_api_key').attr('type', 'text');
                        $('.key-action-hide').removeClass('hidden');
                        $('.key-action-show').addClass('hidden');
                    }
                });
            }

            $('.key-actions').click(function () {
                var keydata = $(this).data('keydata');

                var data = {
                    action: 'magicpage_api_key_hidden',
                    keydata: keydata
                };

                if (keydata) {
                    $('#_magicpage_api_key').attr('type', 'password');
                    $('#hidden-for-all').removeClass('hidden');
                } else {
                    $('#_magicpage_api_key').attr('type', 'text');


                }

                $('.key-actions').toggleClass('hidden');

                $.post(ajaxurl, data, function (response) {

                });
            });

            $('#js_obfuscation').change(function () {
                var element = $(this);

                if (element.val() == 0) {
                    element.validationEngine('showPrompt', "It is highly recommended to use the obfuscation feature", 'red', 'topRight', true);

                    setTimeout(function () {
                        element.validationEngine('hide');
                    }, 3000);

                } else {
                    element.validationEngine('hide');
                }
            });

            $(document).on('click', '#advancedGmap', showAdvancedGmap);
            function showAdvancedGmap() {
                $('#advancedGmapSettings').toggleClass('hidden');
            }

            $('#magic-page-minify-footprint-dialog').on("scroll", function () {
                if (stillScrolling) {
                    return false;
                }

                stillScrolling = true;

                setTimeout(function () {
                    stillScrolling = false;

                    $("#magic-page-minify-settings-form").validationEngine("updatePromptsPosition");
                }, 250);

            });

            $(document).on('click', '#recheckFolderPermissions', recheckFolderPermissions);
            function recheckFolderPermissions() {

                $('#minifyStep1').css('opacity', '0.5');

                var data = {
                    action: 'magicpage_footprint_minify_check_folder_permissions'
                };

                $.post(ajaxurl, data, function (response) {
                    var element = $('#minifyStep1');
                    $(element).replaceWith(response);
                    $('#minifyStep1').removeClass('hidden');
                });
            }

            $(document).on('click', '#minifyBegin', minifyBegin);
            function minifyBegin() {
                $('#minifyStep1').removeClass('hidden');
                $(this).remove();
            }

            $(document).on('click', '#continueMinifyStep2', continueMinifyStep2);
            function continueMinifyStep2() {
                $('#minifyStep2').removeClass('hidden');
                $(this).remove();
            }

            $('#saveFootprint').click(function () {
                if ($('#advancedGmapSettings .formError').length) {

                    showFormAjaxError();

                    return false;
                }

                $('.formError').remove();

                var plugin_folder = $('#plugin_folder').val();
                var post_type_name = $('#post_type_name').val();

                var error = false;

                var requirements = new Array();

                requirements.push({name: 'Plugin Folder', value: plugin_folder, neq: 'magic-page'});
                requirements.push({name: 'Post Type Name', value: post_type_name, neq: 'Magic Page'});

                $.each(requirements, function (i, item) {
                    if (!item.value) {
                        alert('Please enter ' + item.name);
                        error = true;
                    }

                    if (item.value.length < 7) {
                        alert('Please enter ' + item.name + ' with at least 7 characters');
                        error = true;
                    }
                    if (item.value === item.neq) {
                        alert('The field ' + item.name + ' should not be the default one ' + item.neq);
                        error = true;
                    }
                });

                if (error) {
                    return false;
                }

                var data = {
                    action: 'magicpage_footprint_minify_save_data',
                    plugin_folder: plugin_folder,
                    post_type_name: post_type_name,
                    js_filename: $('#js_filename').val(),
                    js_obfuscation: $('#js_obfuscation').val(),
                    js_folder: $('#js_folder').val(),

                    js_classname: $('#js_classname').val(),
                    js_settings: $('#js_settings').val(),
                    js_latitude: $('#js_latitude').val(),
                    js_longitude: $('#js_longitude').val(),
                    js_title: $('#js_title').val()
                };

                $.post(ajaxurl, data, function (response) {
                    if (response.success) {
                        $('#magic-page-minify-footprint-dialog').dialog('close');
                        $('#footprintMiniferBox').attr('class', 'minified');
                        $('#footprintMinify').remove();
                        $('.minify-error-notice').remove();
                    } else {
                        var fieldError = response.data.field;

                        $('#' + fieldError).validationEngine('showPrompt', response.data.note, 'red', 'topRight', true);

                        showFormAjaxError();

                    }
                });
            });


            function showFormAjaxError() {
                $("#magic-page-minify-settings-form").validationEngine("updatePromptsPosition");
                alert('Please fix the form errors before you can continue');
            }

            $('#footprintMinify').click(function () {
                $('#magic-page-minify-footprint-dialog').dialog('open');
                $("#formHolder").wrap('<form id="magic-page-minify-settings-form"></form>');
                $("#magic-page-minify-settings-form").validationEngine();
            });


            function getDialogWidth() {
                if ($(window).width() >= 900) {
                    return 800;
                }

                return 350;
            }


            $('#magic-page-minify-footprint-dialog').dialog({
                title: 'Minify Footprint',
                dialogClass: 'wp-dialog',
                autoOpen: false,
                draggable: true,
                modal: false,
                resizable: true,
                closeOnEscape: true,
                minWidth: 350,
                maxWidth: 900,
                height: $(window).height() - 100,
                width: getDialogWidth(),
                position: {
                    my: "center",
                    at: "center",
                    of: window
                }
            }).trigger('resize');


            ////////////

            $('#magic_page_cron_support').change(function () {
                if ($(this).val() === "basic") {
                    $('#advanced-cron-info').hide();
                } else {
                    $('#advanced-cron-info').show();
                }
            });


            $('#deleteSpintaxCache').click(function () {
                if (confirm("Are you sure you want to delete Spintax Cache?") == true) {
                    var data = {
                        action: 'delete_spintax_cache'
                    };

                    $('#magic_page .loader').show();

                    $.post(window.ajaxurl, data, function (response) {
                        if (response.success == true) {
                            $('#magic_page .loader').hide();
                        }
                    });
                } else {
                    return false;
                }

            });

            $('#_magic_page_spintax_support').change(function () {
                if ($(this).val() === "1") {
                    $('.magic_page_spintax_support').show();
                } else {
                    $('.magic_page_spintax_support').hide();
                }
            });

            $('#_magic_page_spintax_autorewrite').change(function () {
                if ($(this).val() === "1") {
                    $('.magic_page_spintax_autorewrite_options').show();
                } else {
                    $('.magic_page_spintax_autorewrite_options').hide();
                }
            });

            function autorewriteIntervalUpdate() {
                var text = $('#autorewrite-interval option:selected').text().toLowerCase();
                if (text === '1 week') {
                    text = "week";
                }
                if (text === '1 month') {
                    text = "month";
                }
                $('#interval').text(text);
            }

            $('#autorewrite-interval').change(function () {
                autorewriteIntervalUpdate();
            });

            $('#autorewrite-page-coverage').change(function () {
                $('#coverage').text($('#autorewrite-page-coverage option:selected').text());
            });

            $('#autorewrite-posts-amount').change(function () {
                $('#amount').text($('#autorewrite-posts-amount option:selected').text());
            });

            autorewriteIntervalUpdate();

            var url = window.location.href;
            if (url.search("minifier") > 0 && !$('#footprintMiniferBox').hasClass('minified')) {
                setTimeout(function () {
                    $('#footprintMinify').trigger('click');
                }, 1000);
            }

         

        }(MagicPageAdmin));

    });

})(jQuery);
