(function ($) {
    "use strict";

    $(function () {
        var MagicPageAdminDashboard = (function () {


            $('#refresh-magicpage-offers').click(function () {
                $('#discounts-right').css('opacity', '0.2');

                loadOffers();
            });


            $(document).on('click', '#magicpage-discounts .more-discounts', function () {
                $('#magicpage-discounts .discount-row').addClass('hidden');

                var row = $(this).parents('.discount-row');
                if (row.next().length) {
                    row.next().removeClass('hidden');
                } else {
                    $('#magicpage-discounts .discount-row').first().removeClass('hidden');
                }
            });

            function loadOffers() {
                var data = {
                    action: "magic_page_get_dashboard_data",
                  
                };

                $.post(ajaxurl, data, function (response) {
                    $('#discounts-right').css('opacity', '');
                    if (response.success) {
                        processResponse(response.data.data);
                    }
                });
            }

       
            if (!$('#magicpage-discounts').data('offers')) {
                loadOffers();
            } else {
                processResponse($('#magicpage-discounts').data('offers'));
            }


            function processResponse(items) {
                var html = 'No discounts avaialable at this time ';
                if (items && items.length) {
                    var moreLink = '';

                    if (items.length > 1) {
                        moreLink = '<span class="more-discounts">Other Discounts &raquo;</span>'
                    }


                    html = '';
                    $.each(items, function (id, item) {
                        var className = 'discount-row';
                        if (id) {
                            className += ' hidden';
                        }

                        var link = '';
                        var linkend = '';

                        if (item.link) {
                            link = '<a target="_blank" href="' + item.link + '">';
                            linkend = ' &raquo; </a>';
                        }

                        var code = '';
                        if (item.code) {
                            code = ' - ' + item.code;
                        }

                        html += '<div class="' + className + '">' + link + item.title + code + linkend + moreLink + '</div>';
                    });
                }


                $('#magicpage-discounts #discounts-right').html(html);
            }


        }(MagicPageAdminDashboard));
    });
})(jQuery);
 