<?php

if (!defined('ABSPATH')) {
    exit;
}

$minified = is_magic_page_footprint_minifed();
?>

<div class="<?php if ($minified) { ?>minified<?php } else { ?>not-minified<?php } ?>" id="footprintMiniferBox">
    <h3>Footprint Minifier</h3>
    <span id="minifyFootprintIcon">
        <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
             viewBox="0 0 100 100" enable-background="new 0 0 100 100" xml:space="preserve">
            <path fill="#0073b2" id="svgPath" d="M49.8,21.1c7.4,4.5,14.1,6.5,20.3,7.4V60c0,6.5-1.7,7.8-20.3,19.3C49.8,79.3,49.8,21.1,49.8,21.1z
                  M86.3,13.2V60c0,18.7-13,23.5-36.5,38.4C26.3,83.5,13.3,78.6,13.3,60V13.2c14.3,0,22.8-0.5,36.5-12.2C63.4,12.7,72,13.2,86.3,13.2z
                  M78.2,21.2c-9.9-0.5-18.2-2.5-28.4-9.8c-10.1,7.3-18.5,9.3-28.4,9.8V60c0,12.3,6.9,15.5,28.4,28.8C71.3,75.5,78.2,72.3,78.2,60
                  V21.2z"/>
        </svg>
    </span>
    Protect your Magic Page Plugin installation from prying eyes by making it "invisible" for the outside world.
    <div id="minifyCurrentStatus">
        <span id="footprintMinify" class="button button-secondary">Minify Footprint</span>
        <span class="label not-minified"><b>Status</b>: Not Minified</span>
        <span class="label minified"><b>Status</b>: Minified</span>
        
    </div>
</div>

<div id="magic-page-minify-footprint-dialog" class="hidden">
    <div class="protectnote"> <h4>About</h4> This feature will help you protect your installation from prying eyes.
        It will make your plugin installation "invisible" for the outside world. <br /><br />
        Normally it should be done just once, ideally right after your WordPress is installed and the Magic Page Plugin is activated.
        <br /> <br />This feature will alter database records and folder structure - a full backup is highly recommended. <br />
        You will need to set 777 permissions to the plugin folder as well as your wp-content folder.
        We highly recommend returning previous wp-content folder permissions when you're ready.
    </div>

    <div class="protectnote">  <h4>Current Status</h4>
        <?php if ($minified) { ?>  <span class="label minified"><b>Status</b>: Minified</span>  <?php } ?>
        <?php if (!$minified) { ?> <span class="label not-minified"><b>Status</b>: Not Minified</span> <?php } ?>
    </div>

    <span id="minifyBegin" class="button button-secondary">Let's Begin!</span>

    <?php footprintMinifyFolderPermissions(); ?>

    <div class="hidden protectnote" id="minifyStep2">

        <div id="formHolder">
            <h4>Plugin attributes to minify</h4>
            <div class="">Change the fields below with custom values <br /></div>

            <label> Plugin Folder <br />
                <input id="plugin_folder" class="validate[required,minSize[5],custom[custom_key_dash]] inputField" type="text" value="<?php echo(magic_page_plugin_slug()) ?>" />
                <div class="info">Example: my-custom-post-plugin-0123</div>
            </label> 

            <label> Post Type Name <br />
                <input id="post_type_name" class="validate[required,minSize[5]] inputField" type="text" value="<?php echo(magic_page_plugin_post_name()) ?>" />
                <div class="info">Maybe exposed in public by some themes and plugins. Example: Custom WP Post</div>
            </label>

            <b>Google Map Settings</b> <span id="advancedGmap">[Advanced]</span><br /><br />

            <div class="hidden" id="advancedGmapSettings">

                Google Map javascript code if left by default will add footprint which is easily recognizable. 
                By customizing the below fields you will add unique footprint everytime you use the minifier feature.
                Placeholder values are the default ones for the plugin.
                
                <b>You can leave any field blank to generate it automatically.</b>  <br /><br />

                <label> Javascript Obfuscation <br />
                    <select id="js_obfuscation">
                        <option value="1">Enabled</option>
                        <option value="0">Disabled</option>
                    </select>

                    <div class="info">This will protect the JavaScript code used to generate Google maps by adding a significant level of uniqueness & obscurity</div>
                </label>

                <label> Google Map DIV class<br /> 
                    <input class="validate[minSize[5],custom[custom_key],custom[cannotStartWithNumber],custom[cannotMatchOtherField]] inputField" id="js_classname" class="inputField" type="text" placeholder="google_map" />
                    <div class="info">Example: googlemaps </div>
                </label>

                <label> Javascript Filename <br />
                    <input class="validate[minSize[5],custom[custom_key],custom[cannotMatchOtherField]] inputField" id="js_filename"  type="text" placeholder="public" />
                    <div class="info">Example: custom-js-file</div>
                </label>

                <label> Javascript Folder Name <br />
                    <input class="validate[minSize[5],custom[custom_key],custom[cannotMatchOtherField]] inputField" id="js_folder" type="text" placeholder="js" />
                    <div class="info">Example: mysite-js-files</div>
                </label>

                <label> Google Map Settings Parameter  <br /> 
                    <input id="js_settings" class="validate[minSize[5],custom[custom_key],custom[cannotStartWithNumber],custom[cannotMatchOtherField]] inputField" type="text" placeholder="google_map_settings" />
                    <div class="info">Example: my_google_maps_parameters </div>
                </label>

                <label> Latitude Parameter  <br />
                    <input id="js_latitude" class="validate[minSize[5],custom[custom_key],custom[cannotStartWithNumber],custom[cannotMatchOtherField]] inputField" type="text" placeholder="lat" />
                    <div class="info">Example: latitude </div>
                </label>

                <label> Longitude Parameter  <br />
                    <input id="js_longitude" class="validate[minSize[5],custom[custom_key],custom[cannotStartWithNumber],custom[cannotMatchOtherField]] inputField" type="text" placeholder="lon" />
                    <div class="info">Example: longitude </div>
                </label>

                <label> Title Parameter <br />
                    <input id="js_title" class="validate[minSize[5],custom[custom_key],custom[cannotStartWithNumber],custom[cannotMatchOtherField]] inputField" type="text" placeholder="title" />
                    <div class="info">Example: maptitle </div>
                </label>
            </div>

            <span id="saveFootprint" class="button button-secondary">Save & Minify Footprint</span>
        </div>
    </div>
</div>