<?php
if (!defined('ABSPATH')) {
    exit;
}

class MagicPageAdminMetaboxes {

    protected $isGutenberg = false;

    public function __construct() {

        // add_action('admin_enqueue_scripts', array($this, 'wpse_gutenberg_editor_action'));

        add_action('post_submitbox_misc_actions', array($this, 'add_box_autorefresh_content_box'));

        add_action('admin_init', array($this, 'setup_meta_boxes'));
        add_action('save_post', array($this, 'save_post'), 10, 3);

        add_action('post_edit_form_tag', array($this, 'add_edit_form_multipart_encoding'));

        add_filter('admin_body_class', array($this, 'body_class'));

        add_action('wp_ajax_magicpage_location_autosuggest', array($this, 'location_autosuggest'));
        add_action('wp_ajax_magic_page_locations_search', array($this, 'locationSearchSelect2'));

        add_action('wp_ajax_magic_page_create_export_group', array($this, 'createGroup'));
    }

//    function wpse_is_gutenberg_editor() {
//        if (function_exists('is_gutenberg_page') && is_gutenberg_page()) {
//            return true;
//        }
//
//        $current_screen = get_current_screen();
//        if (method_exists($current_screen, 'is_block_editor') && $current_screen->is_block_editor()) {
//            return true;
//        }
//        return false;
//    }
//    function wpse_gutenberg_editor_action() {
//        if ($this->wpse_is_gutenberg_editor()) {
//            $this->isGutenberg = true;
//        } else {
//            $this->isGutenberg = false;
//        }
//    }

    function body_class($classes) {
        global $pagenow, $typenow;

        if (empty($typenow) && !empty($_GET['post'])) {
            $post = get_post($_GET['post']);
            $typenow = $post->post_type;
        }

        if ($pagenow == 'post-new.php' or $pagenow == 'post.php' && $typenow == magic_page_default_post_slug() ||
                (($pagenow == 'post-new.php' or $pagenow == 'post.php') && in_array($typenow, array('post', 'page')))
        ) {
            $data = get_option('_magicpage_d_l');

            if (!$data) {
                return $classes . " magic_page_flag ";
            } else {
                if (is_string($data)) {
                    $data = unserialize($data);
                }
            }



            if (!isset($data["key"]) or $data["flag"] or strlen($data["key"]) !== 20) {
                return $classes . " magic_page_flag ";
            }
        }

        return $classes;
    }

    function setup_meta_boxes() {
        if (current_user_can('administrator') || current_user_can('editor')) {
            add_meta_box('headerfooter', 'Header & Footer Code', array($this, 'headerfooter'), magic_page_default_post_slug(), 'normal', 'low');
            add_meta_box('shortcodes', 'Magic Page Shortcodes', array($this, 'shortcodes'), array(magic_page_default_post_slug(), 'post', 'page'), 'side', 'low');
            add_meta_box('image_box', 'SEO Image', array($this, 'box'), magic_page_default_post_slug(), 'side', 'low');
            add_meta_box('location_and_group', 'Location & Group', array($this, 'location_and_group'), array('page', 'post'), 'side', 'high');

            if (getMagicPageEditor() === 'gutenberg') {
                add_meta_box('add_box_autorefresh_content_box', 'Autorefresh Options', array($this, 'add_box_autorefresh_content_box'), array(magic_page_default_post_slug(), 'post', 'page'), 'side', 'low');
            }
        }
    }

    public function location_and_group() {
        global $post;

        if (empty($post)) {
            return false;
        }

        $location = getMagicpageLocation($post->ID);

        $locationName = 'Default Location';
        $magicPage = get_magic_page();

        if ($magicPage) {
            $defaultLocationId = get_post_meta($magicPage->ID, '_magic_page_default_location', true);

            if ($defaultLocationId) {
                $terms = wp_get_post_terms($magicPage->ID, 'location');

                if ($terms) {
                    foreach ($terms as $term) {
                        if ($term->term_id == $defaultLocationId) {
                            $defaultLocation = get_term_by('id', $defaultLocationId, 'location');
                            $locationName = $defaultLocation->name;
                        }
                    }
                }
            }
        }
        ?> Location   <br /><select name="post_page_location" style="width: 100%" id="post-page-location">
        <?php if ($location) { ?>
                <option value="<?php echo($location->term_id) ?>"> <?php echo($location->name); ?></option>
            <?php } ?></select>

        <div <?php if ($location) { ?>style="display:none" <?php } ?> id="default-location"> Default location: <b><?php echo($locationName); ?></b> </div>


        <p class="howto">Search Location by name or zip code.</p>


        <?php
        $exportGroups = get_option('_magic_page_groups', array());

        $groupId = get_post_meta($post->ID, '_group_id', true);
        ?> Group <br />  <select name="post_page_export_group" style="width: 100%" id="post-page-export-group"><option value="">Select Group</option>
        <?php
        if ($exportGroups) {
            foreach ($exportGroups as $group) {
                ?><option <?php if ($groupId === $group['id']) { ?> selected="selected" <?php } ?>
                                                                      value="<?php echo($group['id']) ?>"> <?php echo($group['title']); ?></option><?php
            }
        }
        ?>



        </select>
        <p title="Search Group or create new one - press Enter" class="howto">Search Group or create new one.</p>
        <?php
    }

    function box($post) {
        $existing_image_id = get_post_meta($post->ID, '_attached_image', true);
        if (is_numeric($existing_image_id)) {

            echo '<div><em>Attached image</em><br /><br />';
            $arr_existing_image = wp_get_attachment_image_src($existing_image_id, 'large');
            $existing_image_url = $arr_existing_image[0];
            echo '<img style="width:100%" src="' . $existing_image_url . '" />';
            echo '</div>';
        }

        echo 'Upload new image: <input type="file" name="image" id="image" />';

        $status_message = get_post_meta($post->ID, '_attached_image_upload_feedback', true);

        if ($status_message) {
            echo '<div class="upload_status_message">';
            echo $status_message;
            echo '</div>';
        }

        echo '<input type="hidden" name="manual_save_flag" value="true" />';
    }

    public function save_post($post_id, $post) {
        $post_type = $post->post_type;

        if ($post_id && current_user_can('edit_post', $post_id) && !defined('DOING_AJAX') && in_array($post_type, array('post', 'page'))) {

            global $wpdb;
            $wpdb->query("DELETE FROM $wpdb->options WHERE option_name LIKE '%_magicpage_cache_query_%'");

            if (isset($_POST['post_page_location'])) {
                $locationId = intval($_POST['post_page_location']);
                if ($locationId) {
                    update_post_meta($post_id, '_location_id', $locationId);
                } else {
                    delete_post_meta($post_id, '_location_id');
                }
            } else {
                delete_post_meta($post_id, '_location_id');
            }


            // export group
            if (isset($_POST['post_page_export_group'])) {
                $exportGroupTitle = isset($_POST['post_page_export_group']) ? sanitize_text_field($_POST['post_page_export_group']) : '';
                $exportGroups = get_option('_magic_page_groups', array());
                $exportGroupId = sanitize_title($exportGroupTitle);

                if ($exportGroupId && !isset($exportGroups[$exportGroupId])) {
                    $exportGroups[$exportGroupId] = array(
                        'id' => $exportGroupId,
                        'title' => $exportGroupTitle,
                        'categories' => array(),
                        'dateCreated' => new DateTime()
                    );

                    update_option('_magic_page_groups', $exportGroups);
                    update_post_meta($post_id, '_group_id', $exportGroupId);
                } else {
                    update_post_meta($post_id, '_group_id', $exportGroupId);
                }
            } else {
                delete_post_meta($post_id, '_group_id');
            }
        }

        if ($post_id && current_user_can('edit_post', $post_id) && isset($_POST['manual_save_flag']) && $post_type == magic_page_default_post_slug()) {



            update_option('_magicpage_headercode', stripslashes(esc_textarea($_POST['headercode'])));
            update_option('_magicpage_footercode', stripslashes(esc_textarea($_POST['footercode'])));

            $refresh_content_status = intval($_POST['_magic_page_autorefresh_content_status']);
            $refresh_content_interval = intval($_POST['_magic_page_autorefresh_content_interval']);
            $refresh_content_coverage = intval($_POST['_magic_page_autorefresh_content_coverage']);
            $refresh_content_locations = intval($_POST['_magic_page_autorefresh_content_locations']);

            update_option('_magic_page_autorefresh_content_status', $refresh_content_status);
            update_option('_magic_page_autorefresh_content_interval', $refresh_content_interval);
            update_option('_magic_page_autorefresh_content_coverage', $refresh_content_coverage);
            update_option('_magic_page_autorefresh_content_locations', $refresh_content_locations);

            if (isset($_FILES['image']) && ($_FILES['image']['size'] > 0)) {
                $arr_file_type = wp_check_filetype(basename($_FILES['image']['name']));
                $uploaded_file_type = $arr_file_type['type'];
                $allowed_file_types = array('image/jpg', 'image/jpeg', 'image/gif', 'image/png');

                if (in_array($uploaded_file_type, $allowed_file_types)) {
                    $upload_overrides = array('test_form' => false);
                    $uploaded_file = wp_handle_upload($_FILES['image'], $upload_overrides);

                    if (isset($uploaded_file['file'])) {
                        $file_name_and_location = $uploaded_file['file'];
                        $file_title_for_media_library = 'your title here';

                        $attachment = array(
                            'post_mime_type' => $uploaded_file_type,
                            'post_title' => 'Uploaded image ' . addslashes($file_title_for_media_library),
                            'post_content' => '',
                            'post_status' => 'inherit'
                        );

                        $attach_id = wp_insert_attachment($attachment, $file_name_and_location);
                        require_once(ABSPATH . "wp-admin" . '/includes/image.php');
                        $attach_data = wp_generate_attachment_metadata($attach_id, $file_name_and_location);
                        wp_update_attachment_metadata($attach_id, $attach_data);

                        $existing_uploaded_image = (int) get_post_meta($post_id, '_attached_image', true);
                        if (is_numeric($existing_uploaded_image)) {
                            wp_delete_attachment($existing_uploaded_image);
                        }

                        update_post_meta($post_id, '_attached_image', $attach_id);

                        $upload_feedback = false;
                    } else {
                        $upload_feedback = 'There was a problem with your upload.';
                        update_post_meta($post_id, '_attached_image', $attach_id);
                    }
                } else {
                    $upload_feedback = 'Please upload only image files (jpg, gif or png).';
                    update_post_meta($post_id, '_attached_image', $attach_id);
                }
            } else {
                $upload_feedback = false;
            }

            update_post_meta($post_id, '_attached_image_upload_feedback', $upload_feedback);
        }
    }

    function add_edit_form_multipart_encoding() {
        echo ' enctype="multipart/form-data" ';
    }

    public function cities_rows() {
        ?>

        <tr>
            <td colspan="2"><div class="shortcode_label">Cities shortcode</div></td>
        </tr>
        <tr>
            <td colspan="2">
                <div class="input-group ">
                    <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_cities" type="text" value="[cities]">
                    <span class="input-group-button">
                        <div class="input-group-button">
                            <button aria-label="Copy to clipboard"  data-clipboard-target="#shortcode_cities" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                        </div>
                    </span>
                </div>
            </td>
        </tr>
        <tr>
            <td> Count:</td>
            <td>
                <input id="shortcode_cities_count" class="recalculate_cities" type="number" min="1" max="100" step="1" value="10" />
            </td>
        </tr>
        <tr>
            <td> Type:</td>
            <td>
                <select class="recalculate_cities" id="shortcode_cities_type">
                    <option value="csv">CSV Links</option>
                    <option value="csvt">CSV Titles</option>
                    <option value="ul">List with Links</option>
                    <option value="ult">List with Titles</option>
                    <option title="Serialized Array for the Advanced Schema Builder" value="array">For Schema Builder</option>
                </select>
            </td>
        </tr>
        <tr>
            <td>Link Label <span class="hint--bottom-right hint--medium" aria-label="Special Tags: %location%, %post_title%, %group%">[?]</span></td>
            <td>
                <input class="recalculate_cities" id="magic_page_link_label" type="text" value="%location%" />
            </td>
        </tr>
        <tr>
            <td> Major Cities:</td>
            <td>
                <select class="recalculate_cities" id="shortcode_major_cities">
                    <option value="">Default (All)</option>
                    <option value="true">Only Major Cities</option>
                    <option value="false">Exclude Major Cities</option>
                </select>
            </td>
        </tr>
        <tr>
            <td>Min Radius:</td>
            <td>
                <input class="recalculate_cities" id="magic_page_min_radius" type="text" value="" />
            </td>
        </tr>
        <tr>
            <td>Max Radius:</td>
            <td>
                <input class="recalculate_cities" id="magic_page_max_radius" type="text" value="" />
            </td>
        </tr>
        <tr>
            <td colspan="2">Counties:</td>
        </tr>
        <tr>
            <td colspan="2">
                <select multiple="multiple"  id="magic_page_counties">
                    <option>%county%</option>
                    <?php foreach ($this->getCounties() as $county) {
                        ?><option><?php echo($county); ?></option>
                    <?php }
                    ?>

                </select>
            </td>
        </tr>

        <!-- for static pages -->

        <tr>
            <td colspan="2">Post type:</td>
        </tr>
        <tr>
            <td colspan="2">
                <select class="recalculate_cities" id="shortcode_post_type">
                    <option value="magicpage">Magic Page (default)</option>
                    <option value="post,page">Posts & Pages</option>
                    <option value="same">Same type as current</option>
                </select>
            </td>
        </tr>

        <tr>
            <td colspan="2">
                <select multiple="multiple" id="shortcode_export_group">

                    <optgroup label="Quick options">
                        <option value="all">All Groups</option>
                        <option value="same">Same as current page (default)</option>

                    </optgroup>
                    <optgroup label="Pick specific Groups">


                        <?php
                        $exportGroups = get_option('_magic_page_groups', array());

                        if ($exportGroups) {
                            foreach ($exportGroups as $exportGroup) {
                                ?><option value="<?php echo($exportGroup['title']); ?>"><?php echo($exportGroup['title']); ?></option>
                                <?php
                            }
                        }
                        ?>
                    </optgroup>
                </select>
            </td>
        </tr>



        <?php
    }

    public function magiclink_rows() {
        ?>

        <tr>
            <td colspan="2"><div class="shortcode_label">Magiclink shortcode</div></td>
        </tr>
        <tr>
            <td colspan="2">
                <div class="input-group ">
                    <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_magiclink" type="text" value="[magiclink]">
                    <span class="input-group-button">
                        <div class="input-group-button">
                            <button aria-label="Copy to clipboard"  data-clipboard-target="#shortcode_magiclink" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                        </div>
                    </span>
                </div>
            </td>
        </tr>


        <tr>
            <td colspan="2">
                <label> Select Location: <br />
                    <select id="shortcode_magiclink_location" class="field recalculate_magiclink"></select>
                </label>
            </td>
        </tr>

        <tr>
            <td>Link Label <span class="hint--bottom-right hint--medium" aria-label=" Special Tags: %location%, %post_title%, %group%">[?]</span></td>
            <td>
                <input class="recalculate_magiclink" id="shortcode_magiclink_label" type="text" value="%location%" placeholder="%location%" />
            </td>
        </tr>


        <tr>
            <td colspan="2">
                <label> Link opens in new window
                    <input class="field recalculate_magiclink" type="checkbox" value="1" id="shortcode_magiclink_new_window" />
                </label>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <label title="Remove the link if it's pointing to the same page as the current"> Remove link if same page
                    <input class="field recalculate_magiclink" type="checkbox" value="1" id="shortcode_magiclink_remove_if_same_page" />
                </label>
            </td>
        </tr>
        <tr>
            <td colspan="2">Post type
                <select class="recalculate_magiclink" id="shortcode_magiclink_post_type">
                    <option value="same">Same type</option>
                    <option value="post,page">Posts & Pages</option>
                    <option value="magicpage">Magic Page</option>
                </select>
            </td>
        </tr>
        <tr>
            <td colspan="2"> Groups</td>
        </tr>
        <tr>
            <td colspan="2">
                <select multiple="multiple" id="shortcode_magiclink_groups">

                    <optgroup label="Quick options">
                        <option value="all">All Groups</option>
                        <option value="same">Same as current page (default)</option>
                    </optgroup>
                    <optgroup label="Pick specific Groups">
                        <?php
                        $exportGroups = get_option('_magic_page_groups', array());

                        if ($exportGroups) {
                            foreach ($exportGroups as $exportGroup) {
                                ?><option value="<?php echo($exportGroup['title']); ?>"><?php echo($exportGroup['title']); ?></option>
                                <?php
                            }
                        }
                        ?>
                    </optgroup>
                </select>
            </td>
        </tr>




        <?php
    }

    public function getCounties() {
        $counties = get_magicpage_counties();

        $out = array();

        $out['%county%'] = '%county%';

        if ($counties) {
            foreach ($counties as $county) {
                // fix regions with comma: W,DC -> W%DC

                if ($county['name']) {
                    $out[$county['name']] = str_replace(', ', '%', $county['name']);
                }
            }
        }



        return $out;
    }

    public function getRegions() {
        $regions = get_magicpage_regions();

        $out = array();

        if ($regions) {
            foreach ($regions as $region) {
                // fix regions with comma: W,DC -> W%DC
                $out[$region['name']] = str_replace(', ', '%', $region['name']);
            }
        }

        return $out;
    }

    public function getLocations() {
        $post = get_magic_page();
        $locations = wp_get_post_terms($post->ID, 'location');

        $out = array();
        foreach ($locations as $location) {
            $out[$location->slug] = $location->name;
        }

        return $out;
    }

    public function headerfooter() {
        ?>
        <table class="form-table">
            <tbody>


                <tr class="widefat">
                    <th scope="row">
                        <label for="headercode">Head Code</label>
                    </th>
                    <td>
                        <textarea name="headercode" class="widefat code" rows="5"><?php echo get_option('_magicpage_headercode') ?></textarea>
                        <p>Example: <code>&lt;link rel="stylesheet" href="/path/to/style.css" type="text/css" media="all"&gt;</code></p>
                        <br />



                    </td>
                </tr>
                <tr class="widefat">
                    <th scope="row">
                        <label for="footercode">Footer Code</label>
                    </th>
                    <td>
                        <textarea name="footercode" class="widefat code" rows="5"><?php echo get_option('_magicpage_footercode') ?></textarea>
                        <p>Example: <code>&lt;script type="text/javascript" src="/path/to/script.js"&gt;&lt;/script&gt;</code></p>
                    </td>
                </tr>
            </tbody>
        </table>
        <?php
    }

    public function shortcodes() {
        ?>



        <div style="display:none" id="shortcodes-accordion">


            <h3>Location</h3>
            <div>

                <table class="mp_shortcodes">

                    <tr>
                        <td colspan="2"><div class="shortcode_label">Location Related Shortcodes</div></td>
                    </tr>

                    <tr>
                        <td>Location</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_location" type="text" value="[location]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard"  data-clipboard-target="#shortcode_location" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>

                    <tr>
                        <td>Slug</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_slug" type="text" value="[slug]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard"  data-clipboard-target="#shortcode_slug" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>

                    <tr>
                        <td>Description</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_description" type="text" value="[description]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard"  data-clipboard-target="#shortcode_description" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>



                    <tr>
                        <td>County</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_county" type="text" value="[county]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard"  data-clipboard-target="#shortcode_county" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Region</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_region" type="text" value="[region]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_region" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Zip <br /><small>(USA only)</small></td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_zip" type="text" value="[zip]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_zip" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Country</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_country" type="text" value="[country]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_country" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Country ISO</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_country_iso" type="text" value="[country_iso]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_country_iso" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Latitude</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_latitude" type="text" value="[latitude]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_latitude" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Longitude</td>
                        <td>
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_longitude" type="text" value="[longitude]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_longitude" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2"><div class="shortcode_label">For Posts & Pages only</div></td>
                    </tr>
                    <tr>
                        <td>Group</td>
                        <td>

                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_group" type="text" value="[group]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_group" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Category</td>
                        <td>

                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_category" type="text" value="[category]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_category" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>




                    <?php
                    $customFields = get_location_custom_meta_fields();

                    if ($customFields) {
                        ?>
                        <tr>
                            <td colspan="2"><div class="shortcode_label">Custom Meta Fields</div></td>
                        </tr>

                        <?php
                        foreach ($customFields as $field) {
                            $label = ucwords(str_replace('_', ' ', $field));
                            ?>

                            <tr>
                                <td><?php echo($label) ?></td>
                                <td>
                                    <div class="input-group">
                                        <input class="form-control input-monospace input-sm js-zeroclipboard-target" id="shortcode_<?php echo($field) ?>" type="text" value="[meta_<?php echo($field) ?>]">
                                        <span class="input-group-button">
                                            <div class="input-group-button">
                                                <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_<?php echo($field) ?>" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                            </div>
                                        </span>
                                    </div>
                                </td>
                            </tr>

                            <?php
                        }
                    }
                    ?>
                </table>


            </div>



            <h3>Cities</h3>
            <div>
                <table class="mp_shortcodes">
                    <?php $this->cities_rows(); ?>
                </table>
            </div>


            <h3>Magiclink</h3>
            <div>
                <table class="mp_shortcodes">
                    <?php $this->magiclink_rows(); ?>
                </table>
            </div>

            <h3>Google Map</h3>
            <div>
                <table class="mp_shortcodes">
                    <tr>
                        <td colspan="2"><div class="shortcode_label">Google Map Shortcode</div></td>
                    </tr>
                    <tr>
                        <td colspan="2">Shortcode:
                            <div class="input-group ">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field recalculate_google_map" id="shortcode_googlemap" type="text" value='[map]'>
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard"  data-clipboard-target="#shortcode_googlemap" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Width:</td>
                        <td><input id="googlemap_width" type="text" value="100" class="field_50 recalculate_google_map" />
                            <select class="recalculate_google_map" id="googlemap_width_type">
                                <option value="%">%</option>
                                <option value="px">px</option>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td>Height:</td>
                        <td class=""><input id="googlemap_height" type="text" class="field_50 recalculate_google_map" value="500" />px</td>
                    </tr>
                    <tr>
                        <td style="white-space: nowrap">Map Zoom <span id="zoom_amount">12</span></td>
                        <td><div id="magic_page_zoom_slider"></div></td>
                    </tr>
                    <tr>
                        <td>Map Type:</td>
                        <td>
                            <select id="googlemap_type" class="recalculate_google_map">
                                <option value="roadmap">Roadmap</option>
                                <option value="satellite">Satellite</option>
                                <option value="hybrid">Hybrid</option>
                                <option value="terrain">Terrain</option>
                            </select>
                        </td>
                    </tr>
                </table>
            </div>


            <!-- -->
            <h3>Other Shortcodes & Builders</h3>

            <div>
                <table class="mp_shortcodes">

                    <tr>
                        <td colspan="2"><div class="shortcode_label">Other Shortcodes</div></td>
                    </tr>

                    <tr>
                        <td>Site Title</td>
                        <td>
                            <div class="input-group">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target" id="shortcode_site_title" type="text" value="[site_title]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_site_title" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>

                    <tr>
                        <td>Site Address (URL)</td>
                        <td>
                            <div class="input-group">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target" id="shortcode_site_url" type="text" value="[site_url]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_site_url" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>

                    <tr>
                        <td>SEO Image Url</td>
                        <td>
                            <div class="input-group">
                                <input class="form-control input-monospace input-sm js-zeroclipboard-target" id="shortcode_seo_image_url" type="text" value="[seo_image_url]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button aria-label="Copy to clipboard" data-clipboard-target="#shortcode_seo_image_url" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </td>
                    </tr>
                    <!-- random -->

                    <tr>
                        <td colspan="2"><div class="shortcode_label">Random Shortcode Builder</div></td>
                    </tr>
                    <tr>
                        <td colspan="2">Create random shortcode [random][/random]</td>
                    </tr>
                    <tr>
                        <td colspan="2"><span id="magic-page-build-new-shortcode-random" style="margin: 15px auto;" class="button magic-page-build-new-shortcode button-secondary">New Random Shortcode</span>
                            <div id="magic-page-new-shortcode-dialog-random" class="hidden">
                                <div class="step">
                                    <div class="step-label">Step 1: </div>
                                    <label>Paste your text:<br />
                                        <textarea id="random-shortcode-text" data-label="Text..." class="text " rows="5" cols="6"> </textarea>
                                    </label>
                                </div>

                                <div id="randomShortcodeSlider" class="step mp_shortcodes ">
                                    <div class="step-label">Step 2: </div>
                                    <label>Set the desired percentage (<span id="randomShortcodePercent">50</span>%) how often the text will be displayed:<br />   </label>


                                    <div id="magic_page_random_shortcode_slider"></div>
                                </div>

                                <div class="step">
                                    <div class="step-label">Step 3: Copy/Paste the shortcode: </div>
                                    <div class="input-group ">
                                        <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field " id="magic-page-random-shortcode" type="text" value='[random chance="50%"]Text...[/random]'>
                                        <span class="input-group-button">
                                            <div class="input-group-button">
                                                <button aria-label="Copy to clipboard" data-clipboard-target="#magic-page-random-shortcode" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                            </div>
                                        </span>
                                    </div>
                                </div>
                            </div>


                        </td>
                    </tr>

                    <tr>
                        <td colspan="2"><div class="shortcode_label">Overlay Code Builder </div></td>
                    </tr>
                    <tr>
                        <td colspan="2">Create Overlay Code</td>
                    </tr>
                    <tr>
                        <td colspan="2"><span id="magic-page-build-new-overlay" style="margin: 15px auto;" class="button   button-secondary">Create Overlay </span>
                            <div id="magic-page-overlay-code-dialog" class="hidden">
                                Create Overlay Code

                                <div class="step">

                                    <div class="step-label">Step 1: Paste URL </div>
                                    <input type="text" id="magic-page-overlay-url" data-label="Paste your content" class="field"  />

                                </div>
                                <div class="step">

                                    <div class="step-label">Step 2: Copy Overlay code & Paste your it in Head code section</div>
                                    <textarea id="copy-magic-page-overlay-url" data-label="Paste your overlay code" class="text " rows="5" cols="6"></textarea>

                                </div>

                            </div>
                        </td>
                    </tr>
                    <!--

                                <tr>
                                    <td colspan="2"><div class="shortcode_label">Protected Content Builder</div></td>
                                </tr>
                                <tr>
                                    <td colspan="2">Use content with brackets {} even when Spintax is enabled</td>
                                </tr>
                                <tr>
                                    <td colspan="2"><span id="magic-page-build-new-protected-content" style="margin: 15px auto;" class="button   button-secondary">Create Protected Content</span>
                                        <div id="magic-page-protected-content-dialog" class="hidden">
                                            Use content with brackets {} even when Spintax is enabled using {%verbatim%}{%endverbatim%} tag

                                            <div class="step">

                                                <div class="step-label">Step 1: Paste your content </div>
                                                <textarea id="magic-page-protected-content" data-label="Paste your content" class="text " rows="5" cols="6"></textarea>

                                            </div>
                                            <div class="step">

                                                <div class="step-label">Step 2: Copy your protected content and use it wherever is needed </div>
                                                <textarea id="copy-protected-content" data-label="Paste your content" class="text " rows="5" cols="6"></textarea>

                                            </div>

                                        </div>
                                    </td>
                                </tr> -->


                    <tr>
                        <td colspan="2"><div class="shortcode_label">Conditional Builder</div></td>
                    </tr>
                    <tr>
                        <td colspan="2">Create location specific [if][else] shortcode</td>
                    </tr>
                    <tr>
                        <td colspan="2"><span id="magic-page-build-new-shortcode" style="margin: 15px auto;" class="button magic-page-build-new-shortcode button-secondary">Build New Shortcode</span>
                            <div id="magic-page-new-shortcode-dialog" class="hidden">
                                <div class="step if">
                                    <div class="step-label">Step 1 (IF) Condition:</div>

                                    <?php require(MAGIC_PAGE_DIR . 'src/admin/conditional-builder-fields.php'); ?>
                                </div>

                                <div class="step elseif">
                                    <div class="step-label">Step 2 (ELSEIF) Conditions (optional): </div>

                                    <?php require(MAGIC_PAGE_DIR . 'src/admin/conditional-builder-fields.php'); ?>
                                    <div>
                                        <span id="add-new-elseif">Add new [elseif]</span>
                                    </div>

                                </div>


                                <div class="step">
                                    <div class="step-label">Step 3 (ELSE) Condition (optional): </div>

                                    <label><b>[ELSE]</b> if <b>none of above conditions are met</b>:<br />
                                        <textarea id="conditonal-else" data-label="Your text if current location matches is not in the chosen Regions/Locations" class="text recalculate_magic-page-conditional-shortcode" rows="5" cols="6"> </textarea>
                                    </label>
                                </div>

                                <div class="step">
                                    <div class="step-label">Step 4 Copy/Paste the shortcode: </div>
                                    <div class="input-group ">
                                        <input class="form-control input-monospace input-sm js-zeroclipboard-target js-url-field recalculate_magic-page-conditional-shortcode" id="magic-page-conditional-shortcode" type="text" value="[if][/if]">
                                        <span class="input-group-button">
                                            <div class="input-group-button">
                                                <button aria-label="Copy to clipboard" data-clipboard-target="#magic-page-conditional-shortcode" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                            </div>
                                        </span>
                                    </div>
                                </div>
                            </div>


                        </td>
                    </tr>






                </table>


            </div>

        </div>





        <?php
    }

    public function location_autosuggest() {
        global $wpdb;
        $taxonomy = 'location';
        $tax = get_taxonomy($taxonomy);

        if (!$tax) {
            wp_die(0);
        }

        if (!current_user_can($tax->cap->assign_terms)) {
            wp_die(-1);
        }

        $s = strip_tags(wp_unslash($_GET['q']));
        $regions = strip_tags(wp_unslash($_GET['regions']));
        $regionsSQL = '';

        if ($regions) {
            $realArray = array_map('trim', explode(',', $regions));
            $stringForIn = "'" . implode("','", $realArray) . "'";
            $regionsSQL = " AND ($wpdb->termmeta.meta_key = 'region' AND $wpdb->termmeta.meta_value IN ($stringForIn)) ";
        }

        $results = $wpdb->get_results(
                "SELECT DISTINCT t.*, tt.*
            FROM $wpdb->terms AS t
            LEFT JOIN $wpdb->termmeta ON (t.term_id = $wpdb->termmeta.term_id )
            LEFT JOIN $wpdb->term_taxonomy AS tt ON t.term_id = tt.term_id
            WHERE tt.taxonomy IN ('$taxonomy') AND (
              ( ($wpdb->termmeta.meta_key = 'zip' AND $wpdb->termmeta.meta_value LIKE '%$s%') OR t.name LIKE '%$s%' OR t.term_id LIKE '%$s%' )
            ) $regionsSQL ORDER BY t.name ASC LIMIT 0, 10");

        // echo($wpdb->last_query); exit();

        $out = array();
        if ($results) {
            foreach ($results as $result) {
                $out[] = array(
                    'id' => $result->term_id,
                    'name' => $result->name,
                    'slug' => $result->slug,
                    'zip' => get_term_meta($result->term_id, 'zip', true),
                );
            }
        }

        wp_send_json_success($out);
    }

    public function locationSearchSelect2() {
        if (!current_user_can('administrator')) {
            wp_send_json_error(array('status' => 'Security Error! Are you sure you\'re logged in?'));
        }
        $taxonomy = 'location';
        $tax = get_taxonomy($taxonomy);

        if (!$tax) {
            wp_die(0);
        }

        if (!current_user_can($tax->cap->assign_terms)) {
            wp_die(-1);
        }

        $s = strip_tags(wp_unslash($_GET['q']));

        global $wpdb;

        $results = $wpdb->get_results(
                "SELECT DISTINCT t.*, tt.*
            FROM $wpdb->terms AS t
            LEFT JOIN $wpdb->termmeta ON (t.term_id = $wpdb->termmeta.term_id )
            LEFT JOIN $wpdb->term_taxonomy AS tt ON t.term_id = tt.term_id
            WHERE tt.taxonomy IN ('location') AND (
              ( ($wpdb->termmeta.meta_key = 'zip' AND $wpdb->termmeta.meta_value LIKE '%$s%') OR t.name LIKE '%$s%' OR t.term_id ='$s' )
            ) ORDER BY t.name ASC LIMIT 0, 20");

        $out = array();
        if ($results) {
            foreach ($results as $result) {


                $out['results'][] = array(
                    'id' => $result->slug,
                    'text' => $result->name . ' (' . $result->term_id . ')',
                );
            }
        }

        header('Content-Type: application/json');
        echo json_encode($out);
        exit();
    }

    function add_box_autorefresh_content_box($post = null) {

        $data = get_option('_magicpage_d_l');
        $_k = null;

        if ($data && !is_array($data)) {
            $unserialized = unserialize($data);

            if ($unserialized && isset($unserialized['key']) && !$unserialized['flag']) {
                if (strlen($unserialized['key']) === 20) {
                    $_k = $unserialized['key'];
                }
            }
        }
        ?>
        <input type="hidden" value="1" name="_is_magic_page" />
        <!-- don't edit this line -->
        <input type="hidden" id="_magicpage_d_l" value="<?php echo($_k); ?>" />
        <!-- don't edit this line -->
        <?php
        if (!is_object($post) or $post->post_type !== magic_page_default_post_slug()) {
            return false;
        }


        $status = get_magic_page_autorefresh_content_status();
        $interval = get_magic_page_autorefresh_content_interval();
        $coverage = get_magic_page_autorefresh_content_coverage();
        $locations = get_magic_page_autorefresh_content_locations();

        if (magic_page_get_spintax_enabled('mp')) {
            ?> <div class="misc-pub-section misc-pub-post-refresh">
                Auto-refresh Spintax content:

                <span id="magic-page-autorefresh-display">
                    <span <?php if (!$status) { ?>style="display:none" <?php } ?> id="content-refresh-status-yes">
                        <b>Yes</b>
                        every <b><span id="content-refresh-interval"><?php echo($interval); ?></span> Days</b>
                        with <b><span id="content-refresh-coverage"><?php echo($coverage); ?></span>%</b> page coverage
                        on  <b><span id="content-refresh-locations"><?php echo($locations); ?></span>%</b> of all locations
                    </span>
                    <span <?php if ($status) { ?>style="display:none" <?php } ?> id="content-refresh-status-no">
                        <b> No </b>
                    </span>
                </span>

                <a href="#" id="edit-magic-page-autorefresh">
                    <span>Edit</span>
                </a>

                <div id="magic-page-autorefresh" style="display: none;">
                    <div id="magic-page-autorefresh-options">
                        <div title="Auto Refresh Status" class="w-25">
                            <label>
                                Status <br />
                                <select id="_magic_page_autorefresh_content_status" name="_magic_page_autorefresh_content_status">
                                    <option <?php if ($status) { ?>selected="selected" <?php } ?> value="1">Yes</option>
                                    <option <?php if (!$status) { ?>selected="selected" <?php } ?> value="0">No</option>
                                </select>
                            </label>
                        </div>

                        <div title="Auto Refresh Interval in Days" class="w-25">
                            <label>
                                Interval <br />
                                <input value="<?php echo($interval); ?>" id="_magic_page_autorefresh_content_interval" name="_magic_page_autorefresh_content_interval" type="number" max="90"  />
                            </label>
                        </div>

                        <div title="Auto Refresh page content coverage %" class="w-25">
                            <label> Coverage<br />
                                <input value="<?php echo($coverage); ?>" id="_magic_page_autorefresh_content_coverage" name="_magic_page_autorefresh_content_coverage" type="number" max="100"  />
                            </label>
                        </div>

                        <div title="Locations % to be refreshed" class="w-25">
                            <label> Locations<br />
                                <input value="<?php echo($locations); ?>" id="_magic_page_autorefresh_content_locations" name="_magic_page_autorefresh_content_locations" type="number" max="100" />
                            </label>
                        </div>

                        <div class="w-25">
                            <span id="save-autorefresh" class="button">OK</span>
                        </div>
                    </div>
                </div>
                <div style="clear: both"></div>

            </div>

        <?php
        }
    }

    public function createGroup() {
        if (!current_user_can('administrator')) {
            return false;
        }

        $groupId = createExportGroup($_POST['groupTitle']);
        $postId = intval($_POST['postId']);

        $post = get_post($postId);

        if ($post) {
            update_post_meta($post->ID, '_magic_page_schema_enabled', 'advanced');
            update_post_meta($post->ID, '_use_group_settings', true);
            wp_send_json_success(['groupId' => $groupId]);
        }


        wp_send_json_error();
    }

}

new MagicPageAdminMetaboxes();
