<?php
if (!defined('ABSPATH')) {
    exit;
}

class MagicPageXfieldsMetabox {

    public function __construct() {
        add_action('admin_init', array($this, 'setup_meta_boxes'));
        add_action('save_post', array($this, 'save_metabox'));
    }

    public function setup_meta_boxes() {

        if (current_user_can('administrator') || current_user_can('editor')) {
            add_meta_box('xfields_box', 'Magic Page xFields', array($this, 'box'), array(magic_page_default_post_slug(), 'post', 'page'), 'normal', 'low');
        }
    }

    public function box() {
        $xfields = get_option('_magic_page_xfields');
        ?>

        <div id="xFieldsTable">
        <?php
        $index = 0;

        if (!empty($xfields)) {

            foreach ($xfields as $id => $xfieldData) {
                ?>
                    <div data-cancel="true" class="viewmode xfieldsItem">
                        <div class="xFieldsValueLabel">
                            Label <br>
                            <div class="input-group ">
                                <input id="xfield_<?php echo $id; ?>" class="xFieldLabel form-control input-monospace input-sm js-zeroclipboard-target js-url-field" type="text" value="[xfield_<?php echo $id; ?>]" readonly="readonly" name="xfields[<?php echo $index ?>][label]">
                                <span class="input-group-button">
                                    <div class="input-group-button">
                                        <button data-clipboard-target="#xfield_<?php echo $id; ?>"  aria-label="Copy to clipboard" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                                    </div>
                                </span>
                            </div>
                        </div>
                        <div class="xFieldsValueTd">
                            Default value for all locations <br />
                            <input type="text" class="xFieldValue" readonly="readonly" name="xfields[<?php echo $index ?>][value]" value="<?php echo htmlspecialchars($xfieldData['value']); ?>" />
                        </div>
                        <div class="xFieldValueActions">
                            Actions <br>
                            <span class="actions">
                                <input type="button" class="button button-primary button-large saveXField" value="Save">
                                <input type="button" class="button button-secondary button-large cancelXfield" value="Cancel">
                                <input type="button" class="button button-secondary button-large editXField" value="Edit">
                                <input type="button" class="button button-secondary button-large deleteXField" value="Delete">
                            </span>
                        </div>

                        <div class="customFieldValues">
                <?php
                if ($xfieldData['custom']) {
                    foreach ($xfieldData['custom'] as $id => $data) {
                        $locations = $data['locations'] ? implode(',', $data['locations']) : '';
                        ?>
                                    <div class="customRow">

                                        <div class="equalFields">
                                            Locations
                                            <div class="input-group">
                                                <input name="xfields[<?php echo $index ?>][custom][<?php echo $id ?>][locations]" value="<?php echo $locations ?>" type="text" class="xFieldLocations form-control input-sm ui-autocomplete-input" autocomplete="off">
                                            </div>
                                        </div>
                                        <div class="equalFields">
                                            Custom value
                                            <input name="xfields[<?php echo $index ?>][custom][<?php echo $id ?>][value]" value="<?php echo htmlspecialchars($data['value']) ?>"  type="text" class="xFieldValue">
                                        </div>
                                        <div class="xFieldValueActionsSmall">
                                            <span class="deleteItemXfield">Delete</span>
                                        </div>
                                    </div>
                        <?php
                    }
                }
                ?>
                            <div style="display:none" class="optional xfieldsCustomValueSample">

                                <div class="equalFields">
                                    Locations
                                    <div class="input-group">
                                        <input type="text" class="xFieldLocations form-control input-sm">
                                    </div>
                                </div>
                                <div class="equalFields">
                                    Custom value
                                    <input type="text" class="xFieldValue"   />
                                </div>
                                <div class="xFieldValueActionsSmall">
                                    <span class="deleteItemXfield">Delete</span>
                                </div>
                            </div>

                            <span class="addCustomValueXField"> Add custom location &amp; value</span>
                        </div>
                    </div>
                <?php
                $index++;
            }
        }
        ?>


            <!-- sample -->
            <div style="display:none" id="xFieldsFormSample">
                <div class="xFieldsValueLabel">
                    Label <br />
                    <div class="input-group ">
                        <input id="" class="xFieldLabel form-control input-monospace input-sm js-zeroclipboard-target js-url-field" id="shortcode_location" type="text" value="" />
                        <span class="input-group-button">
                            <div class="input-group-button">
                                <button data-clipboard-target="" aria-label="Copy to clipboard" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><svg aria-hidden="true" class="octicon octicon-clippy" height="16" version="1.1" viewBox="0 0 14 16" width="14"><path fill-rule="evenodd" d="M2 13h4v1H2v-1zm5-6H2v1h5V7zm2 3V8l-3 3 3 3v-2h5v-2H9zM4.5 9H2v1h2.5V9zM2 12h2.5v-1H2v1zm9 1h1v2c-.02.28-.11.52-.3.7-.19.18-.42.28-.7.3H1c-.55 0-1-.45-1-1V4c0-.55.45-1 1-1h3c0-1.11.89-2 2-2 1.11 0 2 .89 2 2h3c.55 0 1 .45 1 1v5h-1V6H1v9h10v-2zM2 5h8c0-.55-.45-1-1-1H8c-.55 0-1-.45-1-1s-.45-1-1-1-1 .45-1 1-.45 1-1 1H3c-.55 0-1 .45-1 1z"></path></svg></button>
                            </div>
                        </span>
                    </div>
                </div>
                <div class="xFieldsValueTd">
                    Default value for all locations <br />
                    <input type="text" class="xFieldValue" />
                </div>
                <div class="xFieldValueActions">
                    Actions <br />
                    <span class="actions">
                        <input type="button" class="button button-primary button-large saveXField" value="Save" />
                        <input type="button" class="button button-secondary button-large cancelXfield" value="Cancel" />
                        <input type="button" class="button button-secondary button-large editXField" value="Edit" />
                        <input type="button" class="button button-secondary button-large deleteXField" value="Delete" />
                    </span>
                </div>
                <div class="customFieldValues">
                    <div style="display:none" class="optional xfieldsCustomValueSample">
                        <div class="equalFields">
                            Locations
                            <div class="input-group">
                                <input type="text" class="xFieldLocations form-control input-sm" />
                            </div>
                        </div>
                        <div class="equalFields">
                            Custom value
                            <input type="text" class="xFieldValue" />
                        </div>
                        <div class="xFieldValueActionsSmall">
                            <span class="deleteItemXfield">Delete</span>
                        </div>
                    </div>
                    <span class="addCustomValueXField"> Add custom location & value</span>
                </div>
            </div>
            <!-- sample -->
        </div>

        <br />

        <input type="button" class="button button-primary button-large addXfield" value="New xField" />
        <input type="hidden" value="1" name="magic_page_xfields" />

        <?php
    }

    function save_metabox() {
        if (isset($_POST['magic_page_xfields']) && current_user_can('administrator')) {
            $xfields = array();

            if (isset($_POST['xfields']) and!empty($_POST['xfields'])) {

                foreach ($_POST['xfields'] as $data) {
                    if ($data) {
                        $customData = array();
                        if (isset($data['custom']) && $data['custom']) {
                            foreach ($data['custom'] as $id => $item) {
                                if ($item['locations']) {
                                    $locs = array_map('trim', explode(',', rtrim($item['locations'], ',')));
                                    $customData[$id] = array(
                                        'locations' => $locs,
                                        'value' => cleanup_quotes_slashes($item['value'])
                                    );
                                }
                            }
                        }

                        $label = str_replace('[xfield_', '', $data['label']);
                        $label = trim(str_replace(']', '', $label));

                        $xfields[$label] = array('value' => cleanup_quotes_slashes($data['value']), 'custom' => $customData);
                    }
                }
            }
            update_option('_magic_page_xfields', $xfields, 'no');
        }
    }

}

new MagicPageXfieldsMetabox();
